require 'ruby_man/GameObjects/menu'

module RubyMan
  # Helper object for inputting player name
  class PlayerName < Gosu::TextInput
    def filter(text_in)
      return '' if text.size >= 10
      text_in.gsub(/[^A-Za-z0-9]/, '')
    end
  end

  # Game Over screen with enterable player name
  class GameOver < GameObject
    def created
      super
      @text = ResourceManager['text_normal']
      @large_text = ResourceManager['text_large']
      @name = ''
      @input = PlayerName.new
      @game.text_input = @input
    end

    def main_menu
      @game.add_score(@input.text)
      @game.text_input = nil
      @game.main_menu
    end

    def draw
      super
      @large_text.draw_centered('Game over!', x_center, @game.y_res / 6, 0)
      @text.draw_centered('Enter name:', x_center, @game.y_res / 2, 0)
      @text.draw_centered(@input.text, x_center, @game.y_res / 2 + 32, 0)
    end

    def x_center
      @game.x_res / 2
    end

    def button_down(id)
      main_menu if id == Gosu::KbEnter || id == Gosu::KbReturn
    end
  end
end
