require 'ruby_man/GameObjects/moving_object'

module RubyMan
  # simple object representing dying ghost with respawn functionality
  class GhostCorpse < MovingObject
    def initialize(x, y, phase, direction, res_x, res_y)
      super()
      @grid_x, @grid_y, = x, y
      @phase, @direction = phase, direction
      @res_x, @res_y = res_x, res_y
      self.sprite = Sprite['ghost_death']
    end

    def update(delta)
      next_index = @image_index + @image_speed * delta * @sprite.frames.size
      if next_index < @sprite.frames.size
        @image_index = next_index
      else
        respawn
      end
    end

    def respawn
      ghost = Ghost.new
      ghost.set_pos(@res_x, @res_y)
      @game.add_object(ghost)
      destroy
    end
  end
end
