require 'ruby_man/GameObjects/grid_object'
require 'ruby_man/direction'

module RubyMan
  # GridObject with the ability to move smoothly in 4 directions
  class MovingObject < GridObject
    attr_accessor :direction, :phase, :speed

    def initialize
      super
      @direction = Direction.none
      @phase = 0
      @speed = 0
    end

    def update(delta)
      super
      @phase += @speed * delta
      while @phase > 1
        @phase -= 1
        @grid_x += @direction.rel_x
        @grid_y += @direction.rel_y
        grid_step
      end
    end

    def grid_step
    end

    def collision(_other)
    end

    def change_direction(direction)
      @direction = direction
      @image_angle = direction.to_angle
    end

    def direction_free(direction)
      @game.place_free(@grid_x + direction.rel_x, @grid_y + direction.rel_y)
    end

    def pixel_x
      (@grid_x + @direction.rel_x * @phase) * 32
    end

    def pixel_y
      (@grid_y + @direction.rel_y * @phase) * 32
    end
  end
end
