module RubyMan
  # Axis-Aligned Bounding Box
  class AABB
    attr_reader :x_beg, :y_beg
    attr_reader :x_end, :y_end

    def initialize(x_beg, y_beg, x_end, y_end)
      @x_beg, @y_beg = x_beg, y_beg
      @x_end, @y_end = x_end, y_end
    end

    def intersects?(other)
      @x_beg < other.x_end && @x_end > other.x_beg &&
        @y_beg < other.y_end && @y_end > other.y_beg
    end
  end
end
