require 'ruby_man/resource_manager'

module RubyMan
  # drawable animated image
  class Sprite
    attr_accessor :frames
    attr_accessor :width, :height

    def initialize
      @frames = []
    end

    def self.[](resource_name)
      ResourceManager[resource_name]
    end

    def draw(x, y, depth = 0, rotation = 0, frame = 0, scale = 1.0)
      frames[frame].draw_rot(x + @width / 2, y + @height / 2, -depth,
                             rotation, 0.5, 0.5, scale, scale)
    end

    def draw_centered(x, y, depth = 0, rotation = 0, frame = 0, scale = 1.0)
      frames[frame].draw_rot(x, y, -depth, rotation, 0.5, 0.5, scale, scale)
    end
  end
end
